-- ampel.vhd
--
-- Lehrbuch Digitaltechnik
--
-- (c) W. Gehrke, M. Winzker, K. Urbanski, R. Woitowitz, 2016

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity ampel is
   port ( clock_50 : in  std_logic;
          strasse  : out std_logic_vector(2 downto 0); -- rot, gelb, grün
          fussweg  : out std_logic_vector(1 downto 0));-- rot, grün
end ampel;

architecture behave of ampel is

signal  enable  : std_logic;
signal  count_a : unsigned(25 downto 0);
signal  count_b : unsigned( 4 downto 0);

begin

process
begin
wait until rising_edge(clock_50);

   -- Zähler für 1 Impuls je Sekunde
   if (count_a >= 49999999) then
      count_a <= (others => '0');
      enable  <= '1';
   else
      count_a <= count_a + 1;
      enable  <= '0';
   end if;

   -- Zähler für 20 Schritte der Ampel
   if (enable = '1') then
      if (count_b >= 19) then
         count_b <= (others => '0');
      else
         count_b <= count_b + 1;
      end if;
   end if;

   -- Abfrage für Lichter der Ampel
   if     (count_b < 10) then
      -- 10 Sekunden grün für Straße, rot für Fussweg
      strasse <= "001"; fussweg <= "10";
   elsif  (count_b < 11) then
      -- 1 Sekunde gelb für Straße
      strasse <= "010"; fussweg <= "10";
   elsif  (count_b < 12) then
      -- 1 Sekunde rot für Straße
      strasse <= "100"; fussweg <= "10";
   elsif  (count_b < 17) then
      -- 5 Sekunden grün für Fußweg
      strasse <= "100"; fussweg <= "01";
   elsif  (count_b < 19) then
      -- 2 Sekunden rot für Fußweg
      strasse <= "100"; fussweg <= "10";
   else
      -- 1 Sekunde rot/gelb für Straße
      strasse <= "110"; fussweg <= "10";
   end if;
end process;
end;
