-- dmem_dp.vhd
--
-- Lehrbuch Digitaltechnik
--
-- (c) W. Gehrke, M. Winzker, K. Urbanski, R. Woitowitz, 2016

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity dmem_dp is
   generic (
      DW   : integer := 16;    -- Data Width
      AW   : integer := 10 );  -- Address Width
 
    port (
       clk : in  std_logic;    -- Clock
       en  : in  std_logic;    -- Enable
       we  : in  std_logic;    -- Write enable
       a   : in  std_logic_vector(AW-1 downto 0);   -- Address
       d   : in  std_logic_vector(DW-1 downto 0);   -- Data in
       q   : out std_logic_vector(DW-1 downto 0) ); -- Data out
end;

architecture rtl of dmem_dp is
   type tmem is array(0 to 2**AW-1) of std_logic_vector(DW-1 downto 0);
   signal mem : tmem;
begin
   process begin
      wait until rising_edge(clk);
      q <= mem(to_integer(unsigned(a)));
      if en = '1' then
         if we = '1' then
            mem(to_integer(unsigned(a))) <= d;
         end if;
      end if;
   end process; 
end;
