-- entprell.vhd
--
-- Lehrbuch Digitaltechnik
--
-- (c) W. Gehrke, M. Winzker, K. Urbanski, R. Woitowitz, 2016

library ieee;
use ieee.std_logic_1164.all;

entity entprell is
   port ( clk   : in  std_logic;
          reset : in  std_logic;
          x     : in  std_logic;
          y     : out std_logic);
end entprell;

architecture behave of entprell is

   type   state_type is (stabil_0, einmal_1, zweimal_1, 
                         stabil_1, einmal_0, zweimal_0);
   signal state       :  state_type;

begin

process
begin
wait until rising_edge(clk);
   if (reset = '1') then
      state <= stabil_0;
      y     <= '0';
   else
      case state is
         when stabil_0 =>      
            if (x='0') then   state <= stabil_0;    y <= '0';
            else              state <= einmal_1;    y <= '0';
            end if;
         when einmal_1 =>        
            if (x='0') then   state <= stabil_0;    y <= '0';
            else              state <= zweimal_1;   y <= '0';
            end if;
         when zweimal_1 =>       
            if (x='0') then   state <= stabil_0;    y <= '0';
            else              state <= stabil_1;    y <= '1';
            end if;
         when stabil_1 =>      
            if (x='1') then   state <= stabil_1;    y <= '1';
            else              state <= einmal_0;    y <= '1';
            end if;
         when einmal_0 =>        
            if (x='1') then   state <= stabil_1;    y <= '1';
            else              state <= zweimal_0;   y <= '1';
            end if;
         when zweimal_0 =>       
            if (x='1') then   state <= stabil_1;    y <= '1';
            else              state <= stabil_0;    y <= '0';
            end if;
      end case; -- state
   end if; -- reset
end process;
end;
