-- gray_func.vhd
--
-- Lehrbuch Digitaltechnik
--
-- (c) W. Gehrke, M. Winzker, K. Urbanski, R. Woitowitz, 2016

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity gray_func is
  port ( clk      : in  std_logic;
         g_in     : in  std_logic_vector(7 downto 0); 
         b_out    : out std_logic_vector(7 downto 0));
end gray_func;

architecture behave of gray_func is

-- Definition der Funktion Gray2Bin
function Gray2Bin (gray_val : std_logic_vector) return std_logic_vector is
   constant vlen : integer := gray_val 'length;
   variable temp : std_logic_vector(vlen-1 downto 0);
begin
   temp := gray_val;
   if vlen > 1 then 
      for i in vlen-2 downto 0 loop
         temp(i) := gray_val(i) xor temp(i+1);
      end loop;
   end if;
   return temp(vlen-1 downto 0);
end function;


begin

process
begin
wait until rising_edge(clk);

b_out <= Gray2Bin(g_in);
  
end process;
end;
