-- sort_3.vhd
--
-- Lehrbuch Digitaltechnik
--
-- (c) W. Gehrke, M. Winzker, K. Urbanski, R. Woitowitz, 2016

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity sort_3 is
  port ( clk     : in  std_logic;
         i_1     : in  unsigned(7 downto 0); 
         i_2     : in  unsigned(7 downto 0); 
         i_3     : in  unsigned(7 downto 0); 
         o_1     : out unsigned(7 downto 0);
         o_2     : out unsigned(7 downto 0);
         o_3     : out unsigned(7 downto 0));
end sort_3;

architecture behave of sort_3 is

-- Prozedur sort_u3
-- Sortiert 3 Werte vom Datentyp unsigned
procedure sort_u3 (signal val1 : in  unsigned;
                   signal val2 : in  unsigned;
                   signal val3 : in  unsigned;
                   signal min  : out unsigned;
                   signal med  : out unsigned;
                   signal max  : out unsigned ) is

   variable min_v : unsigned(min'length-1 downto 0);
   variable med_v : unsigned(med'length-1 downto 0);
   variable max_v : unsigned(max'length-1 downto 0);
   variable tmp_v : unsigned(min'length-1 downto 0); 

begin
   max_v := val1;
   med_v := val2;
   min_v := val3;
   if min_v >= med_v then -- min/med tauschen?
      tmp_v := med_v;
      med_v := min_v;
      min_v := tmp_v;
   end if;
    
   if med_v >= max_v then -- max/med tauschen?
      tmp_v := max_v;
      max_v := med_v;
      med_v := tmp_v;
   end if;
    
   if min_v >= med_v then -- und noch einmal ggf. min/med tauschen
      tmp_v := med_v;
      med_v := min_v;
      min_v := tmp_v;
   end if;
    
   min <= min_v;
   med <= med_v;
   max <= max_v;
end procedure;

begin

process
begin
wait until rising_edge(clk);

sort_u3 (i_1, i_2, i_3, o_1, o_2, o_3);
  
end process;
end behave;
